'' +--------------------------------------------------------------------------+
'' | Cluso's Propeller Operating System - OS module: _PUT     --> _PUT.CMD    |
'' +--------------------------------------------------------------------------+
'' |  Authors:       (c)2011 by Kwabena W. Agyman (Kye) & J. Moxham (Dr_Acula)|
'' |  Modifications: (c)2012 "Cluso99" (Ray Rodrick)                          |
'' |  License:       MIT License - See end of file for terms of use           |
'' +--------------------------------------------------------------------------+
'' This OS module uses an included module to perform most of the housekeeping.
'' Each module is called from, and returns to, the prop binary "_CMD.CMD"
'' Compile with PropTool + "PreSpin 0.3" by Andy Schenk www.insonix.ch/propeller
'' Compile all modules using Homespun and the OS.BAT file.                              
'' Some OS modules are derived from: 
''      KyeDOS v3 (c) 2011 by Kwabena W. Agyman (Kye) & J. Moxham (Dr_Acula)
'' See the included code for history and acknowledgments.
''
'' RR20130126   This module does file transfers...
''                  PUT <filename.ext> to prop sd card from PC
'' RR20130202   get working but not all types of errors catered for!
'WARNING: File must exist (for now anyway!!)


'#include "__MODULE.spin"       ' include the common code for OS modules (PreSpin)
#include "__MODULE.spin"     


DAT
_ModuleStr    byte      "=== PUT ===",0         'module's name (string)
 
PRI executeCommand(stringPointer) | i, chksum, blksize, ch, filesize
'' PUT command...

'WARNING: File must exist (for now anyway!!)

    fat.openFile(str.tokenizeString(0), "W")

    'there should be an <lf> still in the input buffer, so check and clear it
    i := PeekByte
    if i <> 0
      ch := GetByte
      printbyte(ch)
      
    printbyte("A")                                      ' ACK
    filesize := 0

    repeat
      ' wait for blksize BL & BH
      blksize := GetByte                                ' recv blocksize Lo
      blksize := blksize + (GetByte << 8)               '                Hi
      chksum~                                           ' =0
      if blksize > 0
        ' wait for data block
        repeat i from 1 to blksize 
          ch := GetByte
          chksum += ch                                  ' accum checksum
          fat.writeByte(ch)                             ' write byte to file
      printbyte(chksum & $FF)                           ' send checksum Lo
      printbyte((chksum >> 8) & $FF)                    '               Hi
      filesize += blksize
    until blksize == 0     
    fat.closeFile

    ' all OK so wait for ack
    ch := GetByte                                       ' wait for ACK
    if ch <> "A"
      printbyte("T")
      abort -2
    printbyte("E")                                      ' send END

    ' all done so complete with stats
    PrintString(string("File written to SD card",13,10))
    crlf
    abort 0

dat                                                   
{{
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  |                                                            
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
}}